"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.destroy = exports.dispose = exports.create = exports.default = void 0;

var _rdsdataservice = _interopRequireDefault(require("aws-sdk/clients/rdsdataservice"));

var _resolveReadmodelBase = _interopRequireDefault(require("resolve-readmodel-base"));

var _beginTransaction = _interopRequireDefault(require("./begin-transaction"));

var _buildUpsertDocument = _interopRequireDefault(require("./build-upsert-document"));

var _commitTransaction = _interopRequireDefault(require("./commit-transaction"));

var _coercer = _interopRequireDefault(require("./coercer"));

var _connect2 = _interopRequireDefault(require("./connect"));

var _convertResultRow = _interopRequireDefault(require("./convert-result-row"));

var _count = _interopRequireDefault(require("./count"));

var _defineTable = _interopRequireDefault(require("./define-table"));

var _delete = _interopRequireDefault(require("./delete"));

var _disconnect = _interopRequireDefault(require("./disconnect"));

var _dropReadModel = _interopRequireDefault(require("./drop-read-model"));

var _escapeId = _interopRequireDefault(require("./escape-id"));

var _escape = _interopRequireDefault(require("./escape"));

var _executeStatement = _interopRequireDefault(require("./execute-statement"));

var _findOne = _interopRequireDefault(require("./find-one"));

var _find = _interopRequireDefault(require("./find"));

var _insert = _interopRequireDefault(require("./insert"));

var _rollbackTransaction = _interopRequireDefault(require("./rollback-transaction"));

var _searchToWhereExpression = _interopRequireDefault(require("./search-to-where-expression"));

var _updateToSetExpression = _interopRequireDefault(require("./update-to-set-expression"));

var _update = _interopRequireDefault(require("./update"));

var _create = _interopRequireDefault(require("./resource/create"));

var _dispose = _interopRequireDefault(require("./resource/dispose"));

var _destroy = _interopRequireDefault(require("./resource/destroy"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const store = {
  defineTable: _defineTable.default,
  find: _find.default,
  findOne: _findOne.default,
  count: _count.default,
  insert: _insert.default,
  update: _update.default,
  delete: _delete.default
};

const connect = _connect2.default.bind(null, _objectSpread({
  RDSDataService: _rdsdataservice.default,
  escapeId: _escapeId.default,
  escape: _escape.default,
  buildUpsertDocument: _buildUpsertDocument.default,
  convertResultRow: _convertResultRow.default,
  searchToWhereExpression: _searchToWhereExpression.default,
  updateToSetExpression: _updateToSetExpression.default,
  executeStatement: _executeStatement.default,
  coercer: _coercer.default
}, store));

const createAdapter = _resolveReadmodelBase.default.bind(null, _objectSpread({}, store, {
  connect,
  beginTransaction: _beginTransaction.default,
  commitTransaction: _commitTransaction.default,
  rollbackTransaction: _rollbackTransaction.default,
  dropReadModel: _dropReadModel.default,
  disconnect: _disconnect.default
}));

var _default = createAdapter;
exports.default = _default;
const pool = {
  connect,
  disconnect: _disconnect.default,
  escapeId: _escapeId.default,
  escape: _escape.default
};

const createResource = _create.default.bind(null, pool);

exports.create = createResource;

const disposeResource = _dispose.default.bind(null, pool);

exports.dispose = disposeResource;

const destroyResource = _destroy.default.bind(null, pool);

exports.destroy = destroyResource;
Object.assign(pool, {
  createResource,
  disposeResource,
  destroyResource
});
//# sourceMappingURL=index.js.map